package me.wazup.hideandseek.commands;

import me.wazup.hideandseek.Arena;
import java.util.Map;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;
import me.wazup.hideandseek.Customization;
import me.wazup.hideandseek.Config;
import org.bukkit.ChatColor;
import me.wazup.hideandseek.utils.Utils;
import org.bukkit.entity.Player;
import me.wazup.hideandseek.HideAndSeek;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import me.wazup.hideandseek.commands.admin.TestCommand;
import me.wazup.hideandseek.commands.admin.ReloadCommand;
import me.wazup.hideandseek.commands.admin.CheckCommand;
import me.wazup.hideandseek.commands.admin.PowerupCommand;
import me.wazup.hideandseek.commands.admin.SetModifierCommand;
import me.wazup.hideandseek.commands.admin.ExpCommand;
import me.wazup.hideandseek.commands.admin.CoinsCommand;
import me.wazup.hideandseek.commands.admin.StopCommand;
import me.wazup.hideandseek.commands.admin.StartCommand;
import me.wazup.hideandseek.commands.admin.ResetCommand;
import me.wazup.hideandseek.commands.admin.EditCommand;
import me.wazup.hideandseek.commands.admin.SetGlobalLobby;
import me.wazup.hideandseek.commands.admin.SetLocationCommand;
import me.wazup.hideandseek.commands.admin.DeleteCommand;
import me.wazup.hideandseek.commands.admin.CreateCommand;
import me.wazup.hideandseek.commands.admin.AdminCommand;
import me.wazup.hideandseek.commands.user.AutoJoinCommand;
import me.wazup.hideandseek.commands.user.LeaveCommand;
import me.wazup.hideandseek.commands.user.JoinCommand;
import me.wazup.hideandseek.commands.user.LobbyCommand;
import me.wazup.hideandseek.commands.user.StatsCommand;
import me.wazup.hideandseek.commands.user.ListCommand;
import java.util.HashMap;
import org.bukkit.command.TabCompleter;
import org.bukkit.command.CommandExecutor;

public class MainCommand implements CommandExecutor, TabCompleter
{
    HashMap<String, SubCommand> commands;
    
    public MainCommand() {
        (this.commands = new HashMap<String, SubCommand>()).put("list", (SubCommand)new ListCommand());
        this.commands.put("stats", (SubCommand)new StatsCommand());
        this.commands.put("lobby", (SubCommand)new LobbyCommand());
        this.commands.put("join", (SubCommand)new JoinCommand());
        this.commands.put("leave", (SubCommand)new LeaveCommand());
        this.commands.put("autojoin", (SubCommand)new AutoJoinCommand());
        this.commands.put("admin", (SubCommand)new AdminCommand());
        this.commands.put("create", (SubCommand)new CreateCommand());
        this.commands.put("delete", (SubCommand)new DeleteCommand());
        this.commands.put("setlocation", (SubCommand)new SetLocationCommand());
        this.commands.put("setgloballobby", (SubCommand)new SetGlobalLobby());
        this.commands.put("edit", (SubCommand)new EditCommand());
        this.commands.put("reset", (SubCommand)new ResetCommand());
        this.commands.put("start", (SubCommand)new StartCommand());
        this.commands.put("stop", (SubCommand)new StopCommand());
        this.commands.put("coins", (SubCommand)new CoinsCommand());
        this.commands.put("exp", (SubCommand)new ExpCommand());
        this.commands.put("setmodifier", (SubCommand)new SetModifierCommand());
        this.commands.put("powerup", (SubCommand)new PowerupCommand());
        this.commands.put("check", (SubCommand)new CheckCommand());
        this.commands.put("reload", (SubCommand)new ReloadCommand());
        this.commands.put("editmode", (SubCommand)new ReloadCommand());
        this.commands.put("test", (SubCommand)new TestCommand());
    }
    
    public boolean onCommand(final CommandSender commandSender, final Command command, final String s, final String[] array) {
        final HideAndSeek instance = HideAndSeek.getInstance();
        if (commandSender instanceof Player) {
            Utils.playSound((Player)commandSender, "Command-Execute");
        }
        if (array.length == 0) {
            commandSender.sendMessage(ChatColor.AQUA + "" + ChatColor.STRIKETHROUGH + "------------" + ChatColor.GOLD + " HideAndSeek " + ChatColor.GRAY + "[" + instance.getDescription().getVersion() + "] " + ChatColor.AQUA + "" + ChatColor.STRIKETHROUGH + "------------");
            commandSender.sendMessage(ChatColor.AQUA + " - " + ChatColor.GOLD + "/HideAndSeek | Has " + ChatColor.AQUA + "->" + ChatColor.GREEN + " Main command");
            commandSender.sendMessage(ChatColor.AQUA + " - " + ChatColor.GOLD + "/has List " + ChatColor.AQUA + "->" + ChatColor.GREEN + " Shows a list of arenas");
            if (!Config.getInstance().bungeeEnabled) {
                commandSender.sendMessage(ChatColor.AQUA + " - " + ChatColor.GOLD + "/has Join " + ChatColor.AQUA + "->" + ChatColor.GREEN + " Join a new game");
                commandSender.sendMessage(ChatColor.AQUA + " - " + ChatColor.GOLD + "/has Autojoin " + ChatColor.AQUA + "->" + ChatColor.GREEN + " Join the best available game");
                commandSender.sendMessage(ChatColor.AQUA + " - " + ChatColor.GOLD + "/has Leave " + ChatColor.AQUA + "->" + ChatColor.GREEN + " Leave your current game");
            }
            commandSender.sendMessage(ChatColor.AQUA + " - " + ChatColor.GOLD + "/has Stats " + ChatColor.AQUA + "->" + ChatColor.GREEN + " View your current stats");
            commandSender.sendMessage(ChatColor.AQUA + " - " + ChatColor.GOLD + "/has Lobby " + ChatColor.AQUA + "->" + ChatColor.GREEN + " Teleports to the global lobby");
            commandSender.sendMessage(ChatColor.AQUA + " - " + ChatColor.GOLD + "/has " + (commandSender.hasPermission("hideandseek.admin") ? ChatColor.GREEN : ChatColor.RED) + "Admin " + ChatColor.AQUA + "->" + ChatColor.GREEN + " Shows a list of Admin commands");
            commandSender.sendMessage(ChatColor.AQUA + "" + ChatColor.STRIKETHROUGH + "---------------------------------------");
            return true;
        }
        final String lowerCase = array[0].toLowerCase();
        final Customization customization = instance.customization;
        SubCommand subCommand = null;
        if (this.commands.containsKey(lowerCase)) {
            subCommand = this.commands.get(lowerCase);
        }
        else {
            for (final String key : this.commands.keySet()) {
                if (key.startsWith(lowerCase)) {
                    subCommand = this.commands.get(key);
                    break;
                }
            }
            if (subCommand == null) {
                commandSender.sendMessage((String)customization.messages.get("unknown_command"));
                return true;
            }
        }
        if (!subCommand.allowConsole && !(commandSender instanceof Player)) {
            commandSender.sendMessage((String)customization.messages.get("no_console"));
            return true;
        }
        if (subCommand.permission != null && !commandSender.hasPermission(subCommand.permission)) {
            commandSender.sendMessage((String)customization.messages.get("no_permission"));
            return false;
        }
        if (!subCommand.execute(instance, customization, commandSender, array)) {
            commandSender.sendMessage(customization.messages.get("command_usage").replace("%cmd%", array[0]).replace("%usage%", subCommand.arguments));
        }
        return true;
    }
    
    public List<String> onTabComplete(final CommandSender commandSender, final Command command, final String s, final String[] array) {
        if (array.length == 1) {
            final ArrayList list = new ArrayList();
            for (final Map.Entry entry : this.commands.entrySet()) {
                final SubCommand subCommand = (SubCommand)entry.getValue();
                if (subCommand.permission == null || commandSender.hasPermission(subCommand.permission)) {
                    list.add(entry.getKey());
                }
            }
            return list;
        }
        final String lowerCase = array[0].toLowerCase();
        if (lowerCase.equals("join") || lowerCase.equals("start") || lowerCase.equals("stop") || lowerCase.equalsIgnoreCase("edit") || lowerCase.equals("check") || lowerCase.equals("setlocation")) {
            final ArrayList list2 = new ArrayList();
            final Iterator iterator2 = Arena.arenaObjects.iterator();
            while (iterator2.hasNext()) {
                list2.add(((Arena)iterator2.next()).name);
            }
            return list2;
        }
        return null;
    }
}
